﻿Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.SqlTypes
Imports System.Text
Imports Microsoft.SqlServer.Server

<Serializable()> _
<Microsoft.SqlServer.Server.SqlUserDefinedAggregate(Format.UserDefined, MaxByteSize:=8000)> _
Public Structure Concatenate
    Implements IBinarySerialize

    '' <summary>
    ''' Variable für die Speicherung der Zeichenkette
    ''' </summary>
    Private _Result As StringBuilder

    ''' <summary>
    ''' Konstruktor, einmal pro Gruppierungskriterium
    ''' </summary>
    Public Sub Init()
        Me._Result = New StringBuilder()
    End Sub

    ''' <summary>
    ''' Wird für jeden Wert des Gruppierungskriteriums aufgerufen
    ''' </summary>
    ''' <param name="value">Der zu verarbeitende Wert</param>

#Region "Thats funny"

    'Public Sub Accumulate(ByVal value As SqlString, ByVal separator As SqlChars)
    '    If Not value.IsNull Then
    '        Me._Result.Append(value.Value).Append(separator.Value)
    '    End If
    'End Sub

#End Region

    Public Sub Accumulate(ByVal value As SqlString)
        If Not value.IsNull Then
            Me._Result.Append(value.Value).Append(","c)
        End If
    End Sub

    Public Sub Merge(ByVal value As Concatenate)
        Me._Result.Append(value._Result)
    End Sub

    ''' <summary>
    ''' Abschliessender Aufruf für Gruppierungskriterium, Rückgabe des Ergebnisses
    ''' </summary>
    ''' <returns>Komma getrennte Zeichenkette</returns>
    Public Function Terminate() As SqlString

        Dim sReturn As String = String.Empty

        ' delete the trailing comma, if any
        If Me._Result IsNot Nothing AndAlso Me._Result.Length > 0 Then
            sReturn = Me._Result.ToString(0, Me._Result.Length - 1)
        End If

        Return New SqlString(sReturn)

    End Function

    Public Sub Read(ByVal r As System.IO.BinaryReader) Implements Microsoft.SqlServer.Server.IBinarySerialize.Read
        Me._Result = New StringBuilder(r.ReadString())
    End Sub

    Public Sub Write(ByVal w As System.IO.BinaryWriter) Implements Microsoft.SqlServer.Server.IBinarySerialize.Write
        w.Write(Me._Result.ToString())
    End Sub

End Structure

