﻿Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.SqlTypes
Imports Microsoft.SqlServer.Server
Imports System.Transactions


Partial Public Class StoredProcedures

    <Microsoft.SqlServer.Server.SqlProcedure()> _
    Public Shared Sub RollbackFromUserDefinedProc(ByVal value As SqlDouble)

        ' Verbindung im selben SQL-Kontext herstellen wie der Code, der anfägnlich aufgerufen wurde.
        Using connection As New SqlConnection("context connection=true")

            ' Verbindung öffnen
            connection.Open()

            ' Transaktion fortführen, oder abbrechen?.
            If value * 2 > 10 Then

                SqlContext.Pipe.Send("Alle Bedingungen der benutzerdefinierten Stored Procedure wurden erfüllt. Die Transaktion wird fortgesetzt.")

            Else

                SqlContext.Pipe.Send("Nicht alle Bedingungen der benutzerdefinierten Stored Procedure wurden erfüllt. Die Transaktion wird abgebrochen...")
                Try
                    ' Aktuelle Transaktion abbrechen.
                    Dim trans As Transaction
                    trans = Transaction.Current
                    trans.Rollback()

                Catch ex As SqlException
                    ' Erwartete Exception auffgangen, damit die Verbindung ordnungsgemäß beendet werden kann.                 
                End Try

            End If

            ' Verbindung beenden.
            connection.Close()

        End Using
    End Sub

    ''' <summary>
    ''' Ausführen eines SQL-Befehls, und direktes Zurücksenden an den Client.
    ''' </summary>

    <Microsoft.SqlServer.Server.SqlProcedure()> _
    Public Shared Sub GetSomeData1()

        ' Verbindung im selben SQL-Kontext herstellen wie der Code, der anfägnlich aufgerufen wurde.
        Using connection As New SqlConnection("context connection=true")

            ' Verbindung öffnen
            connection.Open()

            ' Befehl erstellen
            Dim command As New SqlCommand("SELECT * FROM [dbo].[Punkt]", connection)

            ' Befehl ausführen und direkt zurücksenden
            SqlContext.Pipe.ExecuteAndSend(command)

        End Using

    End Sub

    ''' <summary>
    ''' Ausführen eines SQL-Befehls, und Zurücksenden an den Client.
    ''' </summary>

    <Microsoft.SqlServer.Server.SqlProcedure()> _
    Public Shared Sub GetSomeData2()

        ' Verbindung im selben SQL-Kontext herstellen wie der Code, der anfägnlich aufgerufen wurde.
        Using connection As New SqlConnection("context connection=true")

            ' Verbindung öffnen
            connection.Open()

            ' Befehl erstellen
            Dim command As New SqlCommand("SELECT * FROM [dbo].[Punkt]", connection)

            ' Befehl ausführen
            Dim reader As SqlDataReader
            reader = command.ExecuteReader()

            ' Ergebnis zurücksenden
            SqlContext.Pipe.Send(reader)

        End Using

    End Sub

End Class
