USE [SEK4]
GO

-- Beispieltabelle
CREATE TABLE [dbo].[UserRoles]
(
	 [ID] INT IDENTITY(1,1) NOT NULL
	,[Group] NVARCHAR(50)
	,[User] NVARCHAR(50)
)
GO

-- Beispieldatenstze fr Admin Group
INSERT INTO [dbo].[UserRoles] VALUES ('Admin','Peter')
INSERT INTO [dbo].[UserRoles] VALUES ('Admin','Phil')
GO

-- Beispieldatenstze fr User Group
INSERT INTO [dbo].[UserRoles] VALUES ('User','Peter')
INSERT INTO [dbo].[UserRoles] VALUES ('User','Mike')
INSERT INTO [dbo].[UserRoles] VALUES ('User','Tony')
INSERT INTO [dbo].[UserRoles] VALUES ('User','Steve')
INSERT INTO [dbo].[UserRoles] VALUES ('User','Phil')
GO

-- Deployment der Aggregatfunktion: Assembly
CREATE ASSEMBLY CLRSamples 
FROM 'C:\Workshops\SEK4\CLRSample1\CLRSample1\bin\CLRSample1.dll'
WITH PERMISSION_SET = SAFE
GO

-- Deployment der Aggregatfunktion: Aggregatfunktion
-- Name der Assembly (siehe CREATE Assembly Anweisung)
-- Name der Structure inkl. Namespace
CREATE AGGREGATE Concatenate(@input nvarchar(200)) 
RETURNS NVARCHAR(max)
EXTERNAL NAME CLRSamples.[CLRSample1.Concatenate]
GO

-- Prfen
SELECT [User], dbo.Concatenate([Group]) 
FROM [dbo].[UserRoles]
GROUP BY [User]

-- Aktualisierung der Assembly
ALTER ASSEMBLY CLRSamples
FROM 'C:\Workshops\SEK4\CLRSample1\CLRSample1\bin\CLRSample1.dll'
WITH PERMISSION_SET = SAFE
GO

-- geht nicht weil Signatur gendert wurde!!
-- Daher:
DROP AGGREGATE [dbo].[Concatenate]
GO
DROP ASSEMBLY [CLRSamples]
GO

CREATE ASSEMBLY CLRSamples 
FROM 'C:\Workshops\SEK4\CLRSample1\CLRSample1\bin\CLRSample1.dll'
WITH PERMISSION_SET = SAFE
GO

CREATE AGGREGATE Concatenate(@input nvarchar(200),@separator nchar(1)) 
RETURNS NVARCHAR(max)
EXTERNAL NAME CLRSamples.[CLRSample1.Concatenate]
GO

-- Prfen
SELECT [User], dbo.Concatenate([Group],';') 
FROM [dbo].[UserRoles]
GROUP BY [User]
GO


