USE [SEK4]
GO

-- aufrumen 
DROP TABLE [dbo].[Punkt]
GO

-- wenn notwendig
CREATE ASSEMBLY CLRSamples 
FROM 'C:\Workshops\SEK4\CLRSample1\CLRSample1\bin\CLRSample1.dll'
WITH PERMISSION_SET = UNSAFE
GO

-- Tabelle anlegen
CREATE TABLE [dbo].[Punkt]
(
	[Bezeichnung] [nvarchar](10) NOT NULL,
	[Punkt] [dbo].[Point] NOT NULL
)
GO

-- Datenstze einfgen
INSERT INTO [dbo].[Punkt] SELECT * FROM LoadFromFile('C:\Workshops\SEK4\Punkte7.txt')
GO

-- Definition einiger Prozeduren
CREATE PROCEDURE [dbo].[RollbackFromUserDefinedProc] @value [float]
WITH EXECUTE AS CALLER
AS
EXTERNAL NAME CLRSamples.[CLRSample1.StoredProcedures].[RollbackFromUserDefinedProc]
GO

CREATE PROCEDURE [dbo].[GetSomeData1]
WITH EXECUTE AS CALLER
AS
EXTERNAL NAME CLRSamples.[CLRSample1.StoredProcedures].[ExecuteToClient]
GO

CREATE PROCEDURE [dbo].[GetSomeData2]
WITH EXECUTE AS CALLER
AS
EXTERNAL NAME CLRSamples.[CLRSample1.StoredProcedures].[ExecuteToClient2]
GO

-- mal sehen
EXEC [dbo].[GetSomeData1]
GO

EXEC [dbo].[GetSomeData2]
GO


-- leeren wir die Tabelle
TRUNCATE TABLE [dbo].[Punkt]
GO

-- transaktion
BEGIN TRY
	BEGIN TRANSACTION 
	
	INSERT INTO [dbo].[Punkt] ([Bezeichnung],[Punkt])
	VALUES ('Testpunkt','123|304')

	EXEC RollbackFromUserDefinedProc 6
	
	INSERT INTO [dbo].[Punkt] ([Bezeichnung],[Punkt])
	VALUES ('Testpunkt','123|304')

	PRINT N'Commiting transaction...'

	COMMIT TRANSACTION

END TRY
BEGIN CATCH
	PRINT N'Exception thrown, rolling back transaction.'
	ROLLBACK TRANSACTION
	PRINT N'Transaction rolled back.' 
END CATCH

SELECT * FROM [dbo].[Punkt]